/* config file parser functions
 *
 * (C) 2000-2003 by Harald Welte <laforge@gnumonks.org>
 * (C) 2004 by Michal Kwiatkowski <ruby@joker.linuxstuff.pl>
 *
 * This code is released under the terms of GNU GPL.
 */

#ifndef _CONFFILE_H
#define _CONFFILE_H

#include <sys/types.h>


#define CONFIG_LINE_LEN 1024
#define CONFIG_KEY_LEN	32
#define CONFIG_VALUE_LEN (CONFIG_LINE_LEN - CONFIG_KEY_LEN)

enum {
	CONFIG_TYPE_INT,
	CONFIG_TYPE_HEX,
	CONFIG_TYPE_STRING,
	CONFIG_TYPE_BOOLEAN,
	CONFIG_TYPE_MEM,
};

enum {
	CONFIG_OPT_NONE,
	CONFIG_OPT_MANDATORY,
	CONFIG_OPT_MULTI,
	CONFIG_OPT_IGNORE,
};

typedef struct config_entry {
	struct config_entry *	next;
	char			key[CONFIG_KEY_LEN];
	u_int8_t		type,
				options,
				hit;
	union {
		char	string[CONFIG_VALUE_LEN];
		int 	value;
	} u;
} config_entry_t;


int config_open(char *path);
int config_block(char *name);
int config_read(config_entry_t *list);
int config_close(void);


#endif /* conffile.h */

